aboutsummaryrefslogtreecommitdiff
path: root/t
diff options
context:
space:
mode:
authorJunio C Hamano <gitster@pobox.com>2026-03-09 14:36:55 -0700
committerJunio C Hamano <gitster@pobox.com>2026-03-09 14:36:55 -0700
commit5c56c725f104ce278fe1ec0ea0fce0ccfb245aea (patch)
tree148a090bbe73c7bfb8b823bcc642e01c40929250 /t
parent4aa72ea1f64e8ddcd1865c76b24591c0916c0b5d (diff)
parent005f3fbe07a20dd5f7dea57f6f46cd797387e56a (diff)
downloadgit-5c56c725f104ce278fe1ec0ea0fce0ccfb245aea.tar.xz
Merge branch 'ar/run-command-hook-take-2'
Use the hook API to replace ad-hoc invocation of hook scripts via the run_command() API. * ar/run-command-hook-take-2: builtin/receive-pack: avoid spinning no-op sideband async threads receive-pack: convert receive hooks to hook API receive-pack: convert update hooks to new API run-command: poll child input in addition to output hook: add jobs option reference-transaction: use hook API instead of run-command transport: convert pre-push to hook API hook: allow separate std[out|err] streams hook: convert 'post-rewrite' hook in sequencer.c to hook API hook: provide stdin via callback run-command: add stdin callback for parallelization run-command: add helper for pp child states t1800: add hook output stream tests
Diffstat (limited to 't')
-rw-r--r--t/helper/test-run-command.c52
-rwxr-xr-xt/t0061-run-command.sh31
-rwxr-xr-xt/t1800-hook.sh137
3 files changed, 218 insertions, 2 deletions
diff --git a/t/helper/test-run-command.c b/t/helper/test-run-command.c
index 3719f23cc2..4a56456894 100644
--- a/t/helper/test-run-command.c
+++ b/t/helper/test-run-command.c
@@ -23,19 +23,26 @@ static int number_callbacks;
static int parallel_next(struct child_process *cp,
struct strbuf *err,
void *cb,
- void **task_cb UNUSED)
+ void **task_cb)
{
struct child_process *d = cb;
if (number_callbacks >= 4)
return 0;
strvec_pushv(&cp->args, d->args.v);
+ cp->in = d->in;
+ cp->no_stdin = d->no_stdin;
if (err)
strbuf_addstr(err, "preloaded output of a child\n");
else
fprintf(stderr, "preloaded output of a child\n");
number_callbacks++;
+
+ /* test_stdin callback will use this to count remaining lines */
+ *task_cb = xmalloc(sizeof(int));
+ *(int*)(*task_cb) = 2;
+
return 1;
}
@@ -54,15 +61,48 @@ static int no_job(struct child_process *cp UNUSED,
static int task_finished(int result UNUSED,
struct strbuf *err,
void *pp_cb UNUSED,
- void *pp_task_cb UNUSED)
+ void *pp_task_cb)
{
if (err)
strbuf_addstr(err, "asking for a quick stop\n");
else
fprintf(stderr, "asking for a quick stop\n");
+
+ FREE_AND_NULL(pp_task_cb);
+
return 1;
}
+static int task_finished_quiet(int result UNUSED,
+ struct strbuf *err UNUSED,
+ void *pp_cb UNUSED,
+ void *pp_task_cb)
+{
+ FREE_AND_NULL(pp_task_cb);
+ return 0;
+}
+
+static int test_stdin_pipe_feed(int hook_stdin_fd, void *cb UNUSED, void *task_cb)
+{
+ int *lines_remaining = task_cb;
+
+ if (*lines_remaining) {
+ struct strbuf buf = STRBUF_INIT;
+ strbuf_addf(&buf, "sample stdin %d\n", --(*lines_remaining));
+ if (write_in_full(hook_stdin_fd, buf.buf, buf.len) < 0) {
+ if (errno == EPIPE) {
+ /* child closed stdin, nothing more to do */
+ strbuf_release(&buf);
+ return 1;
+ }
+ die_errno("write");
+ }
+ strbuf_release(&buf);
+ }
+
+ return !(*lines_remaining);
+}
+
struct testsuite {
struct string_list tests, failed;
int next;
@@ -157,6 +197,7 @@ static int testsuite(int argc, const char **argv)
struct run_process_parallel_opts opts = {
.get_next_task = next_test,
.start_failure = test_failed,
+ .feed_pipe = test_stdin_pipe_feed,
.task_finished = test_finished,
.data = &suite,
};
@@ -460,12 +501,19 @@ int cmd__run_command(int argc, const char **argv)
if (!strcmp(argv[1], "run-command-parallel")) {
opts.get_next_task = parallel_next;
+ opts.task_finished = task_finished_quiet;
} else if (!strcmp(argv[1], "run-command-abort")) {
opts.get_next_task = parallel_next;
opts.task_finished = task_finished;
} else if (!strcmp(argv[1], "run-command-no-jobs")) {
opts.get_next_task = no_job;
opts.task_finished = task_finished;
+ } else if (!strcmp(argv[1], "run-command-stdin")) {
+ proc.in = -1;
+ proc.no_stdin = 0;
+ opts.get_next_task = parallel_next;
+ opts.task_finished = task_finished_quiet;
+ opts.feed_pipe = test_stdin_pipe_feed;
} else {
ret = 1;
fprintf(stderr, "check usage\n");
diff --git a/t/t0061-run-command.sh b/t/t0061-run-command.sh
index 76d4936a87..2f77fde0d9 100755
--- a/t/t0061-run-command.sh
+++ b/t/t0061-run-command.sh
@@ -164,6 +164,37 @@ test_expect_success 'run_command runs ungrouped in parallel with more tasks than
test_line_count = 4 err
'
+test_expect_success 'run_command listens to stdin' '
+ cat >expect <<-\EOF &&
+ preloaded output of a child
+ listening for stdin:
+ sample stdin 1
+ sample stdin 0
+ preloaded output of a child
+ listening for stdin:
+ sample stdin 1
+ sample stdin 0
+ preloaded output of a child
+ listening for stdin:
+ sample stdin 1
+ sample stdin 0
+ preloaded output of a child
+ listening for stdin:
+ sample stdin 1
+ sample stdin 0
+ EOF
+
+ write_script stdin-script <<-\EOF &&
+ echo "listening for stdin:"
+ while read line
+ do
+ echo "$line"
+ done
+ EOF
+ test-tool run-command run-command-stdin 2 ./stdin-script 2>actual &&
+ test_cmp expect actual
+'
+
cat >expect <<-EOF
preloaded output of a child
asking for a quick stop
diff --git a/t/t1800-hook.sh b/t/t1800-hook.sh
index 4feaf0d7be..ed28a2fadb 100755
--- a/t/t1800-hook.sh
+++ b/t/t1800-hook.sh
@@ -184,4 +184,141 @@ test_expect_success 'stdin to hooks' '
test_cmp expect actual
'
+check_stdout_separate_from_stderr () {
+ for hook in "$@"
+ do
+ # Ensure hook's stdout is only in stdout, not stderr
+ test_grep "Hook $hook stdout" stdout.actual || return 1
+ test_grep ! "Hook $hook stdout" stderr.actual || return 1
+
+ # Ensure hook's stderr is only in stderr, not stdout
+ test_grep "Hook $hook stderr" stderr.actual || return 1
+ test_grep ! "Hook $hook stderr" stdout.actual || return 1
+ done
+}
+
+check_stdout_merged_to_stderr () {
+ for hook in "$@"
+ do
+ # Ensure hook's stdout is only in stderr, not stdout
+ test_grep "Hook $hook stdout" stderr.actual || return 1
+ test_grep ! "Hook $hook stdout" stdout.actual || return 1
+
+ # Ensure hook's stderr is only in stderr, not stdout
+ test_grep "Hook $hook stderr" stderr.actual || return 1
+ test_grep ! "Hook $hook stderr" stdout.actual || return 1
+ done
+}
+
+setup_hooks () {
+ for hook in "$@"
+ do
+ test_hook $hook <<-EOF
+ echo >&1 Hook $hook stdout
+ echo >&2 Hook $hook stderr
+ EOF
+ done
+}
+
+test_expect_success 'client hooks: pre-push expects separate stdout and stderr' '
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ git init --bare remote &&
+ git remote add origin remote &&
+ test_commit A &&
+ setup_hooks pre-push &&
+ git push origin HEAD:main >stdout.actual 2>stderr.actual &&
+ check_stdout_separate_from_stderr pre-push
+'
+
+test_expect_success 'client hooks: commit hooks expect stdout redirected to stderr' '
+ hooks="pre-commit prepare-commit-msg \
+ commit-msg post-commit \
+ reference-transaction" &&
+ setup_hooks $hooks &&
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ git checkout -B main &&
+ git checkout -b branch-a &&
+ test_commit commit-on-branch-a &&
+ git commit --allow-empty -m "Test" >stdout.actual 2>stderr.actual &&
+ check_stdout_merged_to_stderr $hooks
+'
+
+test_expect_success 'client hooks: checkout hooks expect stdout redirected to stderr' '
+ setup_hooks post-checkout reference-transaction &&
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ git checkout -b new-branch main >stdout.actual 2>stderr.actual &&
+ check_stdout_merged_to_stderr post-checkout reference-transaction
+'
+
+test_expect_success 'client hooks: merge hooks expect stdout redirected to stderr' '
+ setup_hooks pre-merge-commit post-merge reference-transaction &&
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ test_commit new-branch-commit &&
+ git merge --no-ff branch-a >stdout.actual 2>stderr.actual &&
+ check_stdout_merged_to_stderr pre-merge-commit post-merge reference-transaction
+'
+
+test_expect_success 'client hooks: post-rewrite hooks expect stdout redirected to stderr' '
+ setup_hooks post-rewrite reference-transaction &&
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ git commit --amend --allow-empty --no-edit >stdout.actual 2>stderr.actual &&
+ check_stdout_merged_to_stderr post-rewrite reference-transaction
+'
+
+test_expect_success 'client hooks: applypatch hooks expect stdout redirected to stderr' '
+ setup_hooks applypatch-msg pre-applypatch post-applypatch &&
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ git checkout -b branch-b main &&
+ test_commit branch-b &&
+ git format-patch -1 --stdout >patch &&
+ git checkout -b branch-c main &&
+ git am patch >stdout.actual 2>stderr.actual &&
+ check_stdout_merged_to_stderr applypatch-msg pre-applypatch post-applypatch
+'
+
+test_expect_success 'client hooks: rebase hooks expect stdout redirected to stderr' '
+ setup_hooks pre-rebase &&
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ git checkout -b branch-d main &&
+ test_commit branch-d &&
+ git checkout main &&
+ test_commit diverge-main &&
+ git checkout branch-d &&
+ git rebase main >stdout.actual 2>stderr.actual &&
+ check_stdout_merged_to_stderr pre-rebase
+'
+
+test_expect_success 'client hooks: post-index-change expects stdout redirected to stderr' '
+ setup_hooks post-index-change &&
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ oid=$(git hash-object -w --stdin </dev/null) &&
+ git update-index --add --cacheinfo 100644 $oid new-file \
+ >stdout.actual 2>stderr.actual &&
+ check_stdout_merged_to_stderr post-index-change
+'
+
+test_expect_success 'server hooks expect stdout redirected to stderr' '
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ git init --bare remote-server &&
+ git remote add origin-server remote-server &&
+ cd remote-server &&
+ setup_hooks pre-receive update post-receive post-update &&
+ cd .. &&
+ git push origin-server HEAD:new-branch >stdout.actual 2>stderr.actual &&
+ check_stdout_merged_to_stderr pre-receive update post-receive post-update
+'
+
+test_expect_success 'server push-to-checkout hook expects stdout redirected to stderr' '
+ test_when_finished "rm -f stdout.actual stderr.actual" &&
+ git init server &&
+ git -C server checkout -b main &&
+ test_config -C server receive.denyCurrentBranch updateInstead &&
+ git remote add origin-server-2 server &&
+ cd server &&
+ setup_hooks push-to-checkout &&
+ cd .. &&
+ git push origin-server-2 HEAD:main >stdout.actual 2>stderr.actual &&
+ check_stdout_merged_to_stderr push-to-checkout
+'
+
test_done